using System;
namespace Volpe.Cafe.Data
{
    [Serializable]
    public sealed class NamePlate : Component
    {
        #region 
        NamePlate() : base() { }
        internal NamePlate(string name) : base()
        {
            this._name = name.Trim().ToUpper();
        }
        #endregion
        #region 
        internal NamePlate Clone()
        {
            NamePlate np = new NamePlate();
            np._name = this._name;
            this.CopyTo(np);
            return np;
        }
        #endregion
        #region 
        public string Name { get { return this._name; } }
        #endregion
        #region 
        string _name;
        #endregion
    }
}

