#region << Using Directives >>
using System;
using System.IO;
using System.Reflection;
using System.Windows.Forms;
#endregion
namespace Volpe.Cafe.Utils
{
    public static class ApplicationInfo
    {
        #region 
        static ApplicationInfo()
        {
            Assembly exeAssembly = Assembly.GetExecutingAssembly();
            ApplicationVersion = exeAssembly.GetName().Version.ToString();
            ApplicationTimestamp = (new FileInfo(exeAssembly.GetFiles()[0].Name)).LastWriteTime.ToString("M/dd/yy H:mm:ss");
            ApplicationPath = Application.StartupPath;
        }
        #endregion
        #region 
        public static readonly string ApplicationVersion;
        public static readonly string ApplicationTimestamp;
        public static readonly string ApplicationPath;
        #endregion
    }
}

