using System;
namespace Volpe.XlLib
{
    [Serializable]
    public struct XlSize
    {
        #region 
        public XlSize(int rows, int columns)
        {
            this.Rows    = rows;
            this.Columns = columns;
        }
        #endregion
        #region 
        public override string ToString()
        {
            return (this.Rows.ToString() + " x " + this.Columns.ToString());
        }
        #endregion
        #region 
        public bool IsEmpty { get { return (this.Rows == 0 && this.Columns == 0); } }
        #endregion
        #region 
        public static readonly XlSize Empty = new XlSize(0, 0);
        public int Rows;
        public int Columns;
        #endregion
    }
}

