#region << Using Directives >>
using System;
using Volpe.Cafe.Utils;
#endregion
namespace Volpe.Cafe.EIS.Data
{
    [Serializable]
    public class EISEmissionsData
    {
        #region 
        public EISEmissionsData(int numYears)
        {
            this._upstream = new double[numYears, numYears + Interaction.CY];
            this._tailpipe = new double[numYears, numYears + Interaction.CY];
            this._total    = new double[numYears, numYears + Interaction.CY];
        }
        #endregion
        #region 
        public double[,] Upstream { get { return this._upstream; } }
        public double[,] Tailpipe { get { return this._tailpipe; } }
        public double[,] Total { get { return this._total; } }
        #endregion
        #region 
        double[,] _upstream;
        double[,] _tailpipe;
        double[,] _total;
        #endregion
    }
}

