#region << Using Directives >>
using System;
#endregion
namespace Volpe.Cafe.EIS.Data
{
    [Serializable]
    public class EISModelData
    {
        #region 
        public EISModelData(int scenCount, int minYear, int maxYear)
        {
            this._cars = new EISAnalysisData[scenCount];
            this._trks = new EISAnalysisData[scenCount];
            for (int i = 0; i < scenCount; i++)
            {
                this._cars[i] = new EISAnalysisData(minYear, maxYear);
                this._trks[i] = new EISAnalysisData(minYear, maxYear);
            }
            this._carsNoCAFE = new EISAnalysisData(minYear, maxYear);
            this._trksNoCAFE = new EISAnalysisData(minYear, maxYear);
        }
        #endregion
        #region 
        public EISAnalysisData[] Cars { get { return this._cars; } }
        public EISAnalysisData[] Trks { get { return this._trks; } }
        public EISAnalysisData CarsNoCAFE { get { return this._carsNoCAFE; } }
        public EISAnalysisData TrksNoCAFE { get { return this._trksNoCAFE; } }
        #endregion
        #region 
        EISAnalysisData[] _cars;    
        EISAnalysisData[] _trks;
        EISAnalysisData   _carsNoCAFE;
        EISAnalysisData   _trksNoCAFE;
        #endregion
    }
}

