#region << Using Directives >>
using System;
using Volpe.Cafe.EIS.Settings;
using Volpe.Cafe.IO;
using Volpe.Cafe.IO.InputParsers;
#endregion
namespace Volpe.Cafe.EIS.IO.InputParsers
{
    public class XlEISParser : XlParser
    {
        #region 
        protected XlEISParser(string path, string password, bool postException) : base(path, password, postException) { }
        #endregion
        #region 
        public static EISTailpipeEmissions ParseEISTailpipeEmissions(string path)
        {
            return ParseEISTailpipeEmissions(path, string.Empty);
        }
        public static EISTailpipeEmissions ParseEISTailpipeEmissions(string path, string password)
        {
            return new XlEISTailpipeEmissionRatesParser(path, password)._value;
        }
        public static EISParameters ParseEISParameters(string path)
        {
            return ParseEISParameters(path, string.Empty);
        }
        public static EISParameters ParseEISParameters(string path, string password)
        {
            return new XlEISParametersParser(path, password)._value;
        }
        #endregion
    }
}

