#region << Using Directives >>
using System;
using System.Collections.Generic;
using Volpe.Cafe.IO.Reporting.CSV;
using Volpe.Cafe.Model;
#endregion
namespace Volpe.Cafe.Optimization.IO.Reporting
{
    [Serializable]
    public class CsvOptimizationReportGenerator : CsvReportGenerator
    {
        #region 
        public CsvOptimizationReportGenerator(ICompliance compliance) : base(compliance) { }
        #endregion
        #region 
        protected override List<CsvReportingBase> OpenReports(int snIndex, string path)
        {
            List<CsvReportingBase> csvReports = base.OpenReports(snIndex, path);
            if (snIndex > 0)
            {
                csvReports.Add(new CsvOptimizationReport(path + "\\optimization_report.csv", (snIndex > 1)));
            }
            return csvReports;
        }
        #endregion
    }
}

