using System;
namespace Volpe.XlLib
{
    [Serializable]
    public sealed class XlNumberFormats
    {
        public const string General = "General";
        public const string PlaintText = "@";
        public const string Standard = "0";
        public const string Numeric = "#,##0";
        public const string NumericDecimal1 = "#,##0.0";
        public const string NumericDecimal2 = "#,##0.00";
        public const string NumericDecimal3 = "#,##0.000";
        public const string NumericDecimal4 = "#,##0.0000";
        public const string Accounting = "_($* #,##0_);_($* (#,##0);_($* \" - \"??_);_(@_)";
        public const string AccountingDecimal1 = "_($* #,##0.0_);_($* (#,##0.0);_($* \" - \"??_);_(@_)";
        public const string AccountingDecimal2 = "_($* #,##0.00_);_($* (#,##0.00);_($* \" - \"??_);_(@_)";
        public const string Percent = "_(* 0%_);_(* (0%);_(* \"- %\"_);_(@_)";
        public const string PercentDecimal1 = "_(* 0.0%_);_(* (0.0%);_(* \"- %\"_);_(@_)";
        public const string PercentDecimal2 = "_(* 0.00%_);_(* (0.00%);_(* \"- %\"_);_(@_)";
    }
}

